
local o = QuickChatlink;

-- Config_t_Init: ()
-- Config_OnEvent_VARIABLES_LOADED: ()
-- Config_HandleSlashCmd_SwapOrder: (args)
--
-- Config_ToggleUseOpenAutoCompletionDoubleBracket: (enable)
-- Config_ToggleUseNormalReplacement: (enable)
-- Config_ToggleUseCloseNormalDoubleBracket: (enable)
-- Config_SwapOrder: (x, y)

-- config = QuickChatlink_Config;




function o.Config_t_Init()
	o.Config_t_Init = nil;
	
	WorldFrame.onVariablesLoadedHandlers[o.Config_OnEvent_VARIABLES_LOADED] = true;
	
	local cmds = o.Localization.SLASH_COMMANDS;
	local slashInfo = {
		[cmds.AUTO_COMPLETION_OPENING_DOUBLE_BRACKET:match("^(%S+)")] = o.Config_ToggleUseOpeningAutoCompletionDoubleBracket;
		[cmds.NORMAL_REPLACEMENT:match("^(%S+)")] = o.Config_ToggleUseNormalReplacement;
		[cmds.NORMAL_CLOSING_DOUBLE_BRACKET:match("^(%S+)")] = o.Config_ToggleUseCloseNormalDoubleBracket;
		[cmds.ORDER:match("^(%S+)")] = o.Config_HandleSlashCmd_SwapOrder;
		[false] = {
			cmds.UNKNOWN;
			cmds.AUTO_COMPLETION_OPENING_DOUBLE_BRACKET;
			cmds.NORMAL_REPLACEMENT;
			cmds.NORMAL_CLOSING_DOUBLE_BRACKET;
			cmds.ORDER;
		};
	};
	NicheDevTools.RegisterSlashCommand("QuickChatlink", slashInfo, "/quickchatlink");
end



function o.Config_OnEvent_VARIABLES_LOADED()
	o.Config_OnEvent_VARIABLES_LOADED = nil;
	
	local config = QuickChatlink_Config;
	if (config == nil or config.sectionOrder ~= nil) then
		config = {
			order = { "Items", "Tradeskills", "Abilities", "Quests", "Talents" };
			noDoubleBracket = true;
			noNormalReplacement = nil;
			normalClosingDoubleBracket = nil;
		};
		QuickChatlink_Config = config;
	end
	o.config = config;
end




do
	local loc_ORDER_LIST = o.Localization.SLASH_COMMANDS.ORDER_LIST;
	
	function o.Config_HandleSlashCmd_SwapOrder(args)
		if (args ~= nil) then
			o.Config_SwapOrder(args:match("^(%S+) (%S+)$"));
		end
		DEFAULT_CHAT_FRAME:AddMessage(loc_ORDER_LIST);
		for index, sectionName in ipairs(order) do
			DEFAULT_CHAT_FRAME:AddMessage(index .. ": " .. sectionName);
		end
	end
end




function o.Config_ToggleUseOpenAutoCompletionDoubleBracket(enable)
	if (enable == nil) then
		enable = (not not o.config.noDoubleBracket);
	end
	enable = ((enable and true) or nil);
	
	o.config.noDoubleBracket = ((enable == nil and true) or nil);
end



function o.Config_ToggleUseNormalReplacement(enable)
	if (enable == nil) then
		enable = (not not o.config.noNormalReplacement);
	end
	enable = ((enable and true) or nil);
	
	o.config.noNormalReplacement = ((enable == nil and true) or nil);
end



function o.Config_ToggleUseCloseNormalDoubleBracket(enable)
	if (enable == nil) then
		enable = (not o.config.normalClosingDoubleBracket);
	end
	enable = ((enable and true) or nil);
	
	o.config.normalClosingDoubleBracket = enable;
end



function o.Config_SwapOrder(to, from)
	local order = o.config.order;
	to, from = tonumber(to), tonumber(from);
	if (order[to] == nil) then
		to = nil;
	end
	if (order[from] == nil) then
		from = nil;
	end
	if (to ~= nil and from ~= nil) then
		local toName = order[to];
		order[to] = order[from];
		order[from] = toName;
	end
end
